---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ k8s_headlamp_release }}-prometheus-proxy
  labels:
    app.kubernetes.io/name: {{ k8s_headlamp_release }}-prometheus-proxy
  annotations:
    source-version: {{ prometheus_proxy_source_version }}
spec:
  replicas: {{ k8s_headlamp_prometheus_proxy_replica_count }}
  selector:
    matchLabels:
      app.kubernetes.io/name: {{ k8s_headlamp_release }}-prometheus-proxy
  template:
    metadata:
      labels:
        app.kubernetes.io/name: {{ k8s_headlamp_release }}-prometheus-proxy
      annotations:
        source-version: {{ prometheus_proxy_source_version }}
    spec:
      containers:
      - name: proxy-server
        image: node:20-alpine
        command:
          - sh
          - -c
          - |
            cd /app
            npm install -g http-proxy
            export NODE_PATH=$(npm root --quiet -g)
            node /app/server.js
        env:
          - name: PROMETHEUS_PROXY_URL
            value: {{ k8s_headlamp_prometheus_proxy_url }}
          - name: PROMETHEUS_PROXY_SECURE
            value: "{{ k8s_headlamp_prometheus_proxy_insecure | lower }}"
        volumeMounts:
        - name: server
          mountPath: /app
        ports:
        - containerPort: 9090
      volumes:
      - name: server
        configMap:
          name: {{ k8s_headlamp_release }}-prometheus-proxy-source
---
apiVersion: v1
kind: Service
metadata:
  name: {{ k8s_headlamp_release }}-prometheus-proxy-svc
  namespace: headlamp
  labels:
    app.kubernetes.io/name: {{ k8s_headlamp_release }}-prometheus-proxy
spec:
  selector:
    app.kubernetes.io/name: {{ k8s_headlamp_release }}-prometheus-proxy
  ports:
  - protocol: TCP
    port: 80
    targetPort: 9090
  type: ClusterIP
